// Copyright (C) 1997 - 1999 Jan Kreft <Kreft@cardiff.ac.uk>

// Eps is Extracellular Polymeric Substance, earlier called Extracellular PolySaccharide

#import "Critter.h"

@interface Eps: Critter { // Critter inherits SwarmObjects

  ResQuant epsDryMass;
  GRate    initVol;

}
// creating ...
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
+create;
-copymom;			// self=mom, returns baby
-liveGrandma: (Species*) s;	// initialize/reinit a default Eps
-setX: (GCoord) cx Y: (GCoord) cy Z: (GCoord) cz Radius: (GCoord) r;
-setX: (GCoord) cx Y: (GCoord) cy Radius: (GCoord) r;

// setting params ...
-addSpeciesParams;
-setConvertBack: (GRate) cb;
-setEpsDensity: (GRate) d;
-setDecayR: (GRate) d;
-setKidSize: (GCoord) ks;

// working ...
-(int) getProcess;

-move;				// based on shoves from neighbors

-(ResQuant) getDryMass;
-(ResQuant) getVolume;

-checkDeath;
-die;
-decay;

-excreteEpsAmount: (ResQuant) e X: (GRate) xi Y: (GRate) yi Z: (GRate) zi;

-step;

// printing ...
-printv;
-printSpheresMatlab;
@end
