// The LandRoot object. vfb rewrite, 951221.

		
#import "Base.h"
#import "Mcr.h"
#import "Quad.h"
#import "Res.h"
#import "Colors.h"
//#import "Critter.h"
#import "Animal.h"
#import "Stat.h"
#import "Site.h"

@interface LandRoot: Quad {
    ResList*	startres;	// bookkeeping--overall at end of stepResources
    ResList*	reservoir;      // bookkeeping--overall now
    ResList*    taxTake;	// bookkeeping--overall
    GRate**     convert;        // not yet--for recycling taxes
}
+create;

-setMcrLX: (GCoord) x1 LY: (GCoord) y1 UX: (GCoord) x2 UY: (GCoord) y2;
-setConvertFrom: (ResType) rfrom To: (ResType) rto Rate: (GRate) newrate;

-feedTree: (Quad*) root; 
-feedTree: (Quad*) root On: (int) roundth; 

// returns amount actually got.  Amount argument may be interpreted as percent.
-(ResQuant) feedCritter: (Animal*) eater Resource: (ResType) res
     Amount: (ResQuant) amount Area: (Mcr*) m;

// If you need to talk to the resource quad directly...returns first it
// finds that produces this resource over that area.  If trying to find for
// an agent, pass myquad->mcr as the area (or its equiv-area square). To
// find the next, pass the previous as "resumefrom".  
-(id) firstQuadProducing: (ResType) res Over: (Mcr*) m;
-(id) nextQuadProducing: (ResType) res Over: (Mcr*) m Last: (id) resumefrom;

-payTaxX: (GCoord) x Y: (GCoord) y 
          Resource: (ResType) res Amount: (ResQuant) amount;
-payTaxX: (GCoord) x Y: (GCoord) y 
          List: (ResList*) list;

-(ResQuant) taxesPaid: (ResType) res;	
-(ResList*) taxesPaid;	
-zeroTaxes;

-stepResourcesOn: (int) roundth;
-stepResources;

-(ResList*) curFeed;	 	  // feedfunc*area, whole tree
-(ResList*) fedOut;	 	  // startres - reservoir, whole tree
-(ResList*) fedOutP;	 	  // same, but percent rather than absolute

-print;
-println;
-printv;

@end
