// replaced random.h, 980407, vfb.

#import <random.h>
#import <objectbase.h>
#import <objectbase/SwarmObject.h>
#import "GeckoControlSwarm.h"

@interface RandSource : SwarmObject {
  @public
	unsigned randomSeed;
  @protected
	id <MT19937gen> generator;
	id <UniformDouble> evenGen;
	id <NormalDist> gaussGen;
}
+create;						// uses timeofday seed
-reSeed: (unsigned) seed;		// replaces generators
-setGen: newGenerator;			// replaces generators--seeding is caller's responsibility
-(double) evenRand;				// 0..1
-(double) gaussRand;			// mean 0, variance 1
-(unsigned long long int) getCurrentCount;
-saveRngState;
-readRngState;
@end

extern RandSource * randSource;
