// vfb, orig, 951020:

#import <gui.h>
#import "Base.h"
#import <space.h>
#import <tkobjc/Raster.h>
#import "Quad.h"
#import "Colors.h"

@interface QuadDisplay: Raster {
  Quad * quadroot;
  GCoord wminx, wminy;
  GCoord wmaxx, wmaxy;
  double ppw;				// pixels per world factor
  BOOL   displayquads;
}

-setQuadToDisplay: (Quad *) q;
-setDisplayQuadFlag: (BOOL) flag;
-setcolormap;

-(int) w2pX: (double) wx;		// world to pixel X
-(int) w2pY: (double) wy;		// world to pixel Y

-(void) drawNode: (Quad*) q;
-drawTree;

// Note: Raster's message drawSelf actually displays the drawing.
// -erase erases the display.
// The draw routines are operating on a pixmap.

@end
