// vfb, orig: 960402

// The Reg module "registers" parameters into archiveable, popupable,
// clump-setable collections.

#import <objectbase.h>		
// vfb, 960403:  2nd try at first pass of Registry--use Probes instead
// of creating our own registry structures.

#import <simtools.h>	

// In this incarnation, Reg (registry) module is an annex of Gecko.m, where
// we attach probes to all the variables we wish to vary and/or inquire about
// with the user.  This incarnation is mostly intended to figure out how the
// probe things work, though....

void makeProbes();

extern ProbeMap* ProgReg;	// program control variables registry
extern ProbeMap* ScenarioReg;	// scenario control variables registry
extern ProbeMap* EvolStratReg;  // Ev.Strategy search control variables registry


